
/**
 * Template controller.
 * @module
 */
define([],
    function() {
        /**
         * Template controller constructor.
         * @class
         * @param name, template controller name, used as the key for compiled template storage
         * @param template
         */
        return function(name, template) {
            // template should be compiled only once
            ich.addTemplate(name, template);
            
            /**
             * Render the data on widget.
             * @param attrs, widget level attributes, specifically, attrs.id should be the exactly same as the attribute id of that widget DOM
             * @param data, mutable business aware data, data has higher priority than attrs when they have the same key
             */
            this.render = function(attrs, data) {
                    // merge objects, deep copy
                    var merged = {};
                    $.extend(true, merged, attrs, data);

                    var html = ich[name](merged);
                    $("widget[name=" + attrs.id + "]").replaceWith(html);
            };
        };
    }
);